#include "mbed.h"
#include "Common.h"
#include "nmea/nmea.h"
#include "mbos.h"
#include "Tasks.h"

Serial gps(NC, GPSRX);

//GPS prototypes
void GpsStringParse(void);
void GpsDist(void);
void Deg2DegMinSec(double DecDeg, DegMinSec *DecSec);
void GpsDist(void);
void Coordinates(void);
void GpsSerialIsr(void);
void trace_h(const char *str, int str_size);
void error_h(const char *str, int str_size);
double trunc(double v);

extern mbos os;
extern int PcMonitor;
extern Serial pc;

nmeaINFO info;                  // Store GPS information 
nmeaPARSER parser;
  
DistAzimuth Path;
nmeaPOS Pos[2];
nmeaINFO Dest;

char msgBuff[2][BUFF_SIZE];     // Receive data buffer from GPS module
                                // Two buffer for double buffering
                                
volatile int writePointer = 0;  // Write pointer for active data buffer
volatile unsigned int bufferSelect = 0; // Active buffer selector

int size;
double latitude, longitude;
double degrees, minutes;